/* ============================================================
 * Date  : 2008-1-20
 * Copyright 2008 Palm, Inc. All rights reserved.
 * ============================================================ */

#ifndef DOCUMENTSERVER_H
#define DOCUMENTSERVER_H
#include <PmIpcServer.h>


#define BDBG(...) \
do { \
    fprintf(stderr, "DSDBG: [%s: %d]: ", __PRETTY_FUNCTION__, __LINE__); \
    fprintf(stderr, __VA_ARGS__); \
    fprintf(stderr, "\n"); \
} while (0)


#define BERR(...) \
do { \
    fprintf(stderr, "DSERR: [%s: %d]: ", __PRETTY_FUNCTION__, __LINE__); \
    fprintf(stderr, __VA_ARGS__); \
    fprintf(stderr, "\n"); \
} while (0)


class DocumentServer {
public:

    static DocumentServer* instance();

    bool init();
    bool run();

    // IPC server callbacks
    bool clientConnection(PmIpcClientContext_t* clientContext, bool attached,
                          void* userData);
    
private:

    DocumentServer();
    ~DocumentServer();
};


#endif/* DOCUMENTSERVER_H */
