#include <signal.h>
#include <stdio.h>
#include <sys/time.h>
#include <time.h>

#include "DocumentServer.h"


static struct timeval gTvStart;

int
main()
{
    ::signal(SIGPIPE, SIG_IGN);

    ::gettimeofday(&gTvStart, 0);
    BDBG("DocumentServer!\n");

    DocumentServer* server = DocumentServer::instance();
    if (!server) {
        BERR("Failed to get instance of server");
        return -1;
    }

    if (!server->init()) {
        BERR("Failed to initialize server");
        return -1;
    }

#if (kDoInitialTiming == 1)
    GMainLoop* pLoop = server->mainLoop();
    GSource* pSource = g_idle_source_new();

    g_source_set_callback(pSource, (GSourceFunc) PrvInitialTimerCallback, NULL, NULL);
    g_source_attach(pSource, g_main_loop_get_context(pLoop));
    g_source_unref(pSource);
#endif

    if (!server->run()) {
        BERR("Failed to run server");
        return -1;
    }

    return 0;
}



